/**
 * # NDDB: N-Dimensional Database
 * Copyright(c) 2013 Stefano Balietti
 * MIT Licensed
 *
 * NDDB is a powerful and versatile object database for node.js and the browser.
 *
 * See README.md for help.
 * ---
 */
(function(e,t,n){function r(e,n){var i;i=this,e=e||{};if(!t)throw new Error("JSUS not found.");this.db=[],this.tags={},this.hooks={insert:[],remove:[],update:[]},this.nddb_pointer=0,r.compatibility.getter?this.__defineGetter__("length",function(){return this.db.length}):this.length=null,this.query=new p,this.addDefaultFilters(),this.__C={},this.__H={},this.__I={},this.__V={},this.__update={},this.__update.pointer=!1,this.__update.indexes=!1,this.__update.sort=!1,this.__shared={},this.log=console.log,this.globalCompare=function(e,t){return-1};var i;i=this,this.comparator("*",function(e,t,n,r){var s,o,u;for(s in e){o=i.getComparator(s),t[s]=t["*"],u=o(e,t);if(u===n)return u;if("undefined"!==r&&u===r)return u}return n===0?r===1?-1:1:n===1?r===0?-1:0:r===0?1:0}),this.init(e),n&&this.importDB(n)}function s(e,t){if(e===null)return;var n=typeof e;if(n==="undefined")return;if(n==="string")return;if(n==="number")return;this.db.push(e),t&&(this._indexIt(e,this.db.length-1),this._hashIt(e),this._viewIt(e)),this.emit("insert",e)}function o(e,t,n){var r,i;return r="(?)",i="Malformed query: "+e||r+" "+t||r+" "+n||r,this.log(i,"WARN"),!1}function u(e,n){return t.obj2Array(e,1)}function a(e,n){return t.obj2KeyedArray(e,1)}function f(e,n){var r=t.getNestedValue(n,e);if("undefined"!=typeof r)return t.obj2Array(r,1)}function l(e,n){var r=t.subobj(e,n);if(!t.isEmpty(r))return t.obj2Array(r,1)}function c(e,n){var r=t.getNestedValue(n,e);if("undefined"!=typeof r)return n.split(".").concat(t.obj2KeyedArray(r))}function h(e,n){var r=t.subobj(e,n);if(!t.isEmpty(r))return t.obj2KeyedArray(r)}function p(){this.reset()}function d(e){return e.cb}function v(e,t){this.idx=e,this.nddb=t,this.resolve={}}r.compatibility=t.compatibility(),e.NDDB=r,r.decycle=function(e){return JSON&&JSON.decycle&&"function"==typeof JSON.decycle&&(e=JSON.decycle(e)),e},r.retrocycle=function(e){return JSON&&JSON.retrocycle&&"function"==typeof JSON.retrocycle&&(e=JSON.retrocycle(e)),e},r.prototype.addFilter=function(e,t){this.filters[e]=t},r.prototype.addDefaultFilters=function(){this.filters||(this.filters={});var e;e=this,this.filters.E=function(n,r,i){return"object"==typeof n?function(n){var i,s;for(i in n){s=e.getComparator(i),r[i]=r[0]["*"];if(s(n,r,1)>0){r[i]=r[1]["*"];if(s(n,r,-1)<0)return n}}if("undefined"!=typeof n[i])return n;if("undefined"!=typeof t.getNestedValue(i,n))return n}:function(e){if("undefined"!=typeof e[n])return e;if("undefined"!=typeof t.getNestedValue(n,e))return e}},this.filters["=="]=function(e,t,n){return function(e){if(n(e,t,0)===0)return e}},this.filters[">"]=function(e,t,n){return"object"==typeof e||e==="*"?function(e){if(n(e,t,1)===1)return e}:function(r){if("undefined"==typeof r[e])return;if(n(r,t,1)===1)return r}},this.filters[">="]=function(e,t,n){return"object"==typeof e||e==="*"?function(e){var r=n(e,t,0,1);if(r===1||r===0)return e}:function(r){if("undefined"==typeof r[e])return;var i=n(r,t,0,1);if(i===1||i===0)return r}},this.filters["<"]=function(e,t,n){return"object"==typeof e||e==="*"?function(e){if(n(e,t,-1)===-1)return e}:function(r){if("undefined"==typeof r[e])return;if(n(r,t,-1)===-1)return r}},this.filters["<="]=function(e,t,n){return"object"==typeof e||e==="*"?function(e){var r=n(e,t,0,-1);if(r===-1||r===0)return e}:function(r){if("undefined"==typeof r[e])return;var i=n(r,t,0,-1);if(i===-1||i===0)return r}},this.filters["><"]=function(t,n,r){return"object"==typeof t?function(e){var i,s;s=t.length;for(i=0;i<s;i++)if(r(e,n[0],1)>0&&r(e,n[1],-1)<0)return e}:t==="*"?function(t){var r,i;for(r in t){i=e.getComparator(r),n[r]=n[0]["*"];if(i(t,n,1)>0){n[r]=n[1]["*"];if(i(t,n,-1)<0)return t}}}:function(e){if(r(e,n[0],1)>0&&r(e,n[1],-1)<0)return e}},this.filters["<>"]=function(e,t,n){return"object"==typeof e||e==="*"?function(e){if(n(e,t[0],-1)<0||n(e,t[1],1)>0)return e}:function(r){if("undefined"==typeof r[e])return;if(n(r,t[0],-1)<0||n(r,t[1],1)>0)return r}},this.filters["in"]=function(e,t,n){return"object"==typeof e?function(e){var r,i;i=t.length;for(r=0;r<i;r++)if(n(e,t[r],0)===0)return e}:function(r){var i,s,o;s={},o=t.length;for(i=0;i<o;i++){s[e]=t[i];if(n(r,s,0)===0)return r}}},this.filters["!in"]=function(e,t,n){return"object"==typeof e?function(e){var r,i;i=t.length;for(r=0;r<i;r++)if(n(e,t[r],0)===0)return;return e}:function(r){var i,s,o;s={},o=t.length;for(i=0;i<o;i++){s[e]=t[i];if(n(r,s,0)===0)return}return r}}},r.prototype.init=function(e){var t,n,r;e=e||{},this.__options=e,e.tags&&(this.tags=e.tags),e.nddb_pointer>0&&(this.nddb_pointer=e.nddb_pointer),e.hooks&&(this.hooks=e.hooks),e.globalCompare&&(this.globalCompare=e.globalCompare),e.update&&("undefined"!=typeof e.update.pointer&&(this.__update.pointer=e.update.pointer),"undefined"!=typeof e.update.indexes&&(this.__update.indexes=e.update.indexes),"undefined"!=typeof e.update.sort&&(this.__update.sort=e.update.sort));if("object"==typeof e.filters)for(t in e.filters)this.addFilter(t,e.filters[t]);if("object"==typeof e.shared)for(n in e.shared)e.shared.hasOwnProperty(n)&&(this.__shared[n]=e.shared[n]);e.log&&this.initLog(e.log,e.logCtx),e.C&&(this.__C=e.C);if(e.H)for(r in e.H)e.H.hasOwnProperty(r)&&this.hash(r,e.H[r]);if(e.I){this.__I=e.I;for(r in e.I)e.I.hasOwnProperty(r)&&this.index(r,e.I[r])}if(e.V){this.__V=e.V;for(r in e.V)e.V.hasOwnProperty(r)&&this.view(r,e.V[r])}},r.prototype.initLog=function(e,t){t=t||this,this.log=function(){return e.apply(t,arguments)}},r.prototype._getConstrName=function(){return this.constructor&&this.constructor.name?this.constructor.name:"NDDB"},r.prototype._autoUpdate=function(e){var n=e?t.merge(this.__update,e):this.__update;n.pointer&&(this.nddb_pointer=this.db.length-1),n.sort&&this.sort(),n.indexes&&this.rebuildIndexes()},r.prototype.importDB=function(e){var n;if(!t.isArray(e))throw new TypeError(this._getConstrName()+".importDB expects an array.");for(n=0;n<e.length;n++)s.call(this,e[n],this.__update.indexes);this._autoUpdate({indexes:!1})},r.prototype.insert=function(e){s.call(this,e,this.__update.indexes),this._autoUpdate({indexes:!1})},r.prototype.size=function(){return this.db.length},r.prototype.breed=function(e){return new this.constructor(this.cloneSettings(),e||this.db)},r.prototype.cloneSettings=function(e){var n,r;n=this.__options||{},r=!0,n.H=this.__H,n.I=this.__I,n.C=this.__C,n.V=this.__V,n.tags=this.tags,n.update=this.__update,n.hooks=this.hooks,n.globalCompare=this.globalCompare,n=t.clone(n);for(i in e)if(e.hasOwnProperty(i)){if(i==="shared"){r=!1;continue}delete n[i]}return r&&(n.shared=this.__shared),n},r.prototype.toString=function(){var e,t;e="";for(t=0;t<this.db.length;t++)e+=this.db[t]+"\n";return e},r.prototype.stringify=function(e){if(!this.length)return"[]";e="undefined"==typeof e?!0:e;var n=e?0:4,i="[";return this.each(function(e){e=r.decycle(e),i+=t.stringify(e)+", "}),i=i.replace(/, $/,"]"),i},r.prototype.comparator=function(e,t){if("undefined"==typeof e)throw new TypeError(this._getConstrName()+".comparator: undefined dimension.");if("function"!=typeof t)throw new TypeError(this._getConstrName()+".comparator: comparator must be function.");return this.__C[e]=t,!0},r.prototype.c=r.prototype.comparator,r.prototype.getComparator=function(e){var n,r,s;if("string"==typeof e)"undefined"!=typeof this.__C[e]?r=this.__C[e]:r=function(r,i){var s,o;return"undefined"==typeof r&&"undefined"==typeof i?0:"undefined"==typeof r?1:"undefined"==typeof i?-1:("undefined"!=typeof r[e]?s=r[e]:e.lastIndexOf(".")!==-1&&(s=t.getNestedValue(e,r)),"undefined"!=typeof i[e]?o=i[e]:e.lastIndexOf(".")!==-1&&(o=t.getNestedValue(e,i)),"undefined"==typeof s&&"undefined"==typeof o?0:"undefined"==typeof s?1:"undefined"==typeof o?-1:s>o?1:o>s?-1:0)};else{s={},n=e.length;for(i=0;i<n;i++)s[e[i]]=this.getComparator(e[i]);r=function(e,t,n,r){var i,o,u;for(i in s)if(s.hasOwnProperty(i)){if("undefined"==typeof e[i])continue;u={},u[i]=t,o=s[i](e,u);if(o===n)return o;if("undefined"!==r&&o===r)return o}return n===0?r===1?-1:1:n===1?r===0?-1:0:r===0?1:0}}return r},r.prototype.isReservedWord=function(e){return this[e]?!0:!1},r.prototype.index=function(e,t){if("string"!=typeof e&&"number"!=typeof e)throw new TypeError(this._getConstrName()+".index: "+"idx must be string or number.");if(this.isReservedWord(e))throw new Error(this._getConstrName()+".index: "+"idx is reserved word ("+e+")");if("function"!=typeof t)throw new TypeError(this._getConstrName()+".view: "+"func must be function.");return this.__I[e]=t,this[e]=new v(e,this),!0},r.prototype.i=r.prototype.index,r.prototype.view=function(e,t){var n;if("string"!=typeof e&&"number"!=typeof e)throw new TypeError(this._getConstrName()+".view: "+"idx must be string or number.");if(this.isReservedWord(e))throw new Error(this._getConstrName()+".view: "+"idx is reserved word ("+e+")");if("function"!=typeof t)throw new TypeError(this._getConstrName()+".view: "+"func must be function.");return n=this.cloneSettings({V:""}),this.__V[e]=t,this[e]=new r(n),!0},r.prototype.hash=function(e,t){if("string"!=typeof e&&"number"!=typeof e)throw new TypeError(this._getConstrName()+".hash: "+"idx must be string or number.");if(this.isReservedWord(e))throw new Error(this._getConstrName()+".hash: "+"idx is reserved word ("+e+")");if("function"!=typeof t)throw new TypeError(this._getConstrName()+".hash: "+"func must be function.");return this.__H[e]=t,this[e]={},!0},r.prototype.h=r.prototype.hash,r.prototype.resetIndexes=function(e){var n,r;r=e||t.merge({h:!0,v:!0,i:!0},e);if(r.h)for(n in this.__H)this.__H.hasOwnProperty(n)&&(this[n]={});if(r.v)for(n in this.__V)this.__V.hasOwnProperty(n)&&(this[n]=new this.constructor);if(r.i)for(n in this.__I)this.__I.hasOwnProperty(n)&&(this[n]=new v(n,this))},r.prototype.rebuildIndexes=function(){var e=!t.isEmpty(this.__H),n=!t.isEmpty(this.__I),r=!t.isEmpty(this.__V),i,s;if(!e&&!n&&!r)return;this.resetIndexes({h:e,v:r,i:n}),e&&!n&&!r?i=this._hashIt:!e&&n&&!r?i=this._indexIt:!e&&!n&&r?i=this._viewIt:e&&n&&!r?i=function(e,t){this._hashIt(e),this._indexIt(e,t)}:!e&&n&&r?i=function(e,t){this._indexIt(e,t),this._viewIt(e)}:e&&!n&&r?i=function(e,t){this._hashIt(e),this._viewIt(e)}:i=function(e,t){this._indexIt(e,t),this._hashIt(e),this._viewIt(e)};for(s=0;s<this.db.length;s++)i.call(this,this.db[s],s)},r.prototype._indexIt=function(e,n){var r,i,s,o;if(!e||t.isEmpty(this.__I))return;for(o in this.__I)if(this.__I.hasOwnProperty(o)){r=this.__I[o],s=r(e);if("undefined"==typeof s)continue;this[o]||(this[o]=new v(o,this)),this[o]._add(s,n)}},r.prototype._viewIt=function(e){var n,i,s,o,u;if(!e||t.isEmpty(this.__V))return!1;for(o in this.__V)if(this.__V.hasOwnProperty(o)){n=this.__V[o],s=n(e);if("undefined"==typeof s)continue;this[o]||(u=this.cloneSettings({V:""}),this[o]=new r(u)),this[o].insert(e)}},r.prototype._hashIt=function(e){var n,i,s,o,u;if(!e||t.isEmpty(this.__H))return!1;for(o in this.__H)if(this.__H.hasOwnProperty(o)){n=this.__H[o],s=n(e);if("undefined"==typeof s)continue;this[o]||(this[o]={}),this[o][s]||(u=this.cloneSettings({H:""}),this[o][s]=new r(u)),this[o][s].insert(e)}},r.prototype.on=function(e,t){if(!e||!t||!this.hooks[e])return;return this.hooks[e].push(t),!0},r.prototype.off=function(e,t){var n;if(!e||!this.hooks[e]||!this.hooks[e].length)return;if(!t)return this.hooks[e]=[],!0;for(n=0;n<this.hooks[e].length;n++)if(this.hooks[e][n]==t)return this.hooks[e].splice(n,1),!0;return!1},r.prototype.emit=function(e,t){var n;if(!e||!this.hooks[e]||!this.hooks[e].length)return;for(n=0;n<this.hooks[e].length;n++)this.hooks[e][n].call(this,t)},r.prototype._analyzeQuery=function(e,n,r){var i,s,u,a;i=this;if("undefined"==typeof e)return o.call(this,e,n,r);if("undefined"!=typeof n){n==="="&&(n="==");if(!(n in this.filters))return this.log("Query error. Invalid operator detected: "+n,"WARN"),!1;if(t.in_array(n,["><","<>","in","!in"])){r instanceof Array||(this.log("Range-queries need an array as third parameter","WARN"),o.call(this,e,n,r));if(n==="<>"||n==="><")t.isArray(e)||(r[0]=t.setNestedValue(e,r[0]),r[1]=t.setNestedValue(e,r[1]))}else if(t.in_array(n,[">","==",">=","<","<="])){"undefined"==typeof r&&o.call(this,e,n,r);if(t.isArray(e)){u=e.length;for(s=0;s<u;s++)t.setNestedValue(e[s],r)}else r=t.setNestedValue(e,r)}}else"undefined"!=typeof r?o.call(this,e,n,r):(n="E",r="");return{d:e,op:n,value:r}},r.prototype.distinct=function(){return this.breed(t.distinct(this.db))},r.prototype.select=function(e,t,n){return this.query.reset(),arguments.length?this.and(e,t,n):this},r.prototype.and=function(e,t,n){var r,i;return r=this._analyzeQuery(e,t,n),r?(i=this.filters[r.op](r.d,r.value,this.getComparator(r.d)),this.query.addCondition("AND",i),this):!1},r.prototype.or=function(e,t,n){var r,i;return r=this._analyzeQuery(e,t,n),r?(i=this.filters[r.op](r.d,r.value,this.getComparator(r.d)),this.query.addCondition("OR",i),this):!1},r.prototype.selexec=function(e,t,n){return this.select(e,t,n).execute()},r.prototype.execute=function(){return this.filter(this.query.get.call(this.query))},r.prototype.exists=function(e){if(!e)return!1;for(var n=0;n<this.db.length;n++)if(t.equals(this.db[n],e))return!0;return!1},r.prototype.limit=function(e){e=e||0;if(e===0)return this.breed();var t=e>0?this.db.slice(0,e):this.db.slice(e);return this.breed(t)},r.prototype.reverse=function(){return this.db.reverse(),this},r.prototype.sort=function(e){var t,n;return e?"function"==typeof e?t=e:e instanceof Array?(n=this,t=function(t,r){var i,s;for(i=0;i<e.length;i++){s=n.getComparator(e[i]).call(n,t,r);if(s!==0)return s}return s}):t=this.getComparator(e):t=this.globalCompare,this.db.sort(t),this},r.prototype.shuffle=function(){return this.db=t.shuffle(this.db),this},r.prototype.filter=function(e){return this.breed(this.db.filter(e))},r.prototype.each=r.prototype.forEach=function(){if(arguments.length===0)return;var e=arguments[0],t;for(t=0;t<this.db.length;t++)arguments[0]=this.db[t],e.apply(this,arguments)},r.prototype.map=function(){if(arguments.length===0)return;var e=arguments[0],t=[],n,r;for(r=0;r<this.db.length;r++)arguments[0]=this.db[r],n=e.apply(this,arguments),"undefined"!=typeof n&&t.push(n);return t},r.prototype.update=function(e){if(!this.db.length||!e)return this;for(var n=0;n<this.db.length;n++)t.mixin(this.db[n],e),this.emit("update",this.db[n]);return this._autoUpdate(),this},r.prototype.removeAllEntries=function(){return this.db.length?(this.emit("remove",this.db),this.db=[],this._autoUpdate(),this):this},r.prototype.clear=function(e){if(e){this.db=[],this.tags={},this.query.reset(),this.nddb_pointer=0;var t;for(t in this.__H)this[t]&&delete this[t];for(t in this.__C)this[t]&&delete this[t];for(var t in this.__I)this[t]&&delete this[t]}else this.log("Do you really want to clear the current dataset? Please use clear(true)","WARN");return e},r.prototype.join=function(e,n,r,i){return this._join(e,n,t.equals,r,i)},r.prototype.concat=function(e,t,n,r){return this._join(e,t,function(){return!0},n,r)},r.prototype._join=function(e,n,r,i,s){var o,u,a,f,l,c,h,p;if(!e||!n)return this.breed([]);r=r||t.equals,i="undefined"!=typeof i?i:"joined",s&&(s=s instanceof Array?s:[s]),o=[],u=[];for(l=0;l<this.db.length;l++){a=t.getNestedValue(e,this.db[l]);if("undefined"!=typeof a)for(c=l+1;c<this.db.length;c++)f=t.getNestedValue(n,this.db[c]),"undefined"!=typeof f&&r(a,f)&&(h=t.clone(this.db[l]),p=s?t.subobj(this.db[c],s):this.db[c],h[i]=p,o.push(h))}return this.breed(o)},r.prototype.split=function(e){var n=[],r;for(r=0;r<this.db.length;r++)n=n.concat(t.split(this.db[r],e));return this.breed(n)},r.prototype.fetch=function(){return this.db},r.prototype.fetchSubObj=function(e){if(!e)return[];var n,r,i=[];for(n=0;n<this.db.length;n++)r=t.subobj(this.db[n],e),t.isEmpty(r)||i.push(r);return i},r.prototype.fetchValues=function(e){var n,r,i,s;s=typeof e,i={};if(s==="undefined")for(r=0;r<this.db.length;r++)t.augment(i,this.db[r],t.keys(this.db[r]));else if(s==="string"){i[e]=[];for(r=0;r<this.db.length;r++)n=t.getNestedValue(e,this.db[r]),"undefined"!=typeof n&&i[e].push(n)}else if(t.isArray(e)){i=t.melt(e,t.rep([],e.length));for(r=0;r<this.db.length;r++)n=t.subobj(this.db[r],e),t.isEmpty(n)||t.augment(i,n)}return i},r.prototype._fetchArray=function(e,t){var n,r,i,s;t?e?"string"==typeof e?n=c:n=h:n=a:e?"string"==typeof e?n=f:n=l:n=u,r=[];for(s=0;s<this.db.length;s++)i=n.call(this.db[s],this.db[s],e),"undefined"!=typeof i&&r.push(i);return r},r.prototype.fetchArray=function(e){return this._fetchArray(e)},r.prototype.fetchKeyArray=function(e){return this._fetchArray(e,!0)},r.prototype.groupBy=function(e){if(!e)return this.db;var n=[],r=[],i,s,o;for(i=0;i<this.db.length;i++){s=t.getNestedValue(e,this.db[i]);if("undefined"==typeof s)continue;t.in_array(s,n)||(n.push(s),o=this.filter(function(n){if(t.equals(t.getNestedValue(e,n),s))return this}),o.nddb_pointer=0,r.push(o))}return r},r.prototype.count=function(e){if("undefined"==typeof e)return this.db.length;var n=0;for(var r=0;r<this.db.length;r++)t.hasOwnNestedProperty(e,this.db[r])&&n++;return n},r.prototype.sum=function(e){if("undefined"==typeof e)return!1;var n=0;for(var r=0;r<this.db.length;r++){var i=t.getNestedValue(e,this.db[r]);isNaN(i)||(n+=i)}return n},r.prototype.mean=function(e){if("undefined"==typeof e)return!1;var n=0,r=0;for(var i=0;i<this.db.length;i++){var s=t.getNestedValue(e,this.db[i]);isNaN(s)||(n+=s,r++)}return r===0?0:n/r},r.prototype.stddev=function(e){var n,r,i;return"undefined"==typeof e?!1:(r=this.mean(e),isNaN(r)?!1:(n=0,i=0,this.each(function(s){var o=t.getNestedValue(e,s);isNaN(o)||(n+=Math.pow(o-r,2),i++)}),n!==0?Math.sqrt(n)/(i-1):0))},r.prototype.min=function(e){if("undefined"==typeof e)return!1;var n=!1;for(var r=0;r<this.db.length;r++){var i=t.getNestedValue(e,this.db[r]);!isNaN(i)&&(i<n||n===!1)&&(n=i)}return n},r.prototype.max=function(e){if("undefined"==typeof e)return!1;var n=!1;for(var r=0;r<this.db.length;r++){var i=t.getNestedValue(e,this.db[r]);!isNaN(i)&&(i>n||n===!1)&&(n=i)}return n},r.prototype.skim=function(e){return e?this.breed(this.map(function(n){var r=t.skim(n,e);if(!t.isEmpty(r))return r})):this},r.prototype.keep=function(e){return e?this.breed(this.map(function(n){var r=t.subobj(n,e);if(!t.isEmpty(r))return r})):this.breed([])},r.prototype.diff=function(e){return!e||!e.length?this:("object"==typeof e&&(e instanceof r||e instanceof this.constructor)&&(e=e.db),this.breed(t.arrayDiff(this.db,e)))},r.prototype.intersect=function(e){if(!e||!e.length)return this;if("object"==typeof e)if(e instanceof r||e instanceof this.constructor)var e=e.db;return this.breed(t.arrayIntersect(this.db,e))},r.prototype.get=function(e){return"undefined"==typeof e||e<0||e>this.db.length-1?!1:this.db[e]},r.prototype.current=function(){return this.nddb_pointer<0||this.nddb_pointer>this.db.length-1?!1:this.db[this.nddb_pointer]},r.prototype.next=function(){this.nddb_pointer++;var e=r.prototype.current.call(this);return e||this.nddb_pointer--,e},r.prototype.previous=function(){this.nddb_pointer--;var e=r.prototype.current.call(this);return e||this.nddb_pointer++,e},r.prototype.first=function(e){var t=this.fetch(e);return t.length?(this.nddb_pointer=0,t[0]):undefined},r.prototype.last=function(e){var t=this.fetch(e);return t.length?(this.nddb_pointer=t.length-1,t[t.length-1]):undefined},r.prototype.tag=function(e,t){var n,r;if("string"!=typeof e&&"number"!=typeof e)throw new TypeError(this._getConstrName()+".tag: tag must be string or number.");n=null,r=typeof t;if(r==="undefined")n=this.db[this.nddb_pointer];else if(r==="number"){if(t>this.length||t<0)throw new TypeError(this._getConstrName()+".tag: invalid index provided");n=this.db[t]}else n=t;return this.tags[e]=n,n},r.prototype.resolveTag=function(e){if("string"!=typeof e)throw new TypeError(this._getConstrName()+".resolveTag: tag must be string.");return this.tags[e]},r.prototype.storageAvailable=function(){return"function"==typeof n},r.prototype.save=function(e,t,r){if("string"!=typeof e)throw new TypeError(this._getConstrName()+"load: you must specify a valid file name.");r=r||!1;if(!this.storageAvailable())throw new Error(this._getConstrName()+".save: no support for persistent storage.");return n(e,this.stringify(r)),t&&t(),!0},r.prototype.load=function(e,i,s){var o,u;if("string"!=typeof e)throw new TypeError(this._getConstrName()+".load: you must specify a valid file name.");if(!this.storageAvailable())throw new Error(this._getConstrName()+".load: no support for persistent storage found.");o=n(e);if("undefined"==typeof o)return this.log(this._getConstrName()+".load: nothing found to load","WARN"),!1;"string"==typeof o&&(o=t.parse(o));if(!t.isArray(o))throw new TypeError(this._getConstrName()+".load: expects to load an array.");for(u=0;u<o.length;u++)o[u]=r.retrocycle(o[u]);return this.importDB(o),!0},p.prototype.addCondition=function(e,t){this.query[this.pointer].push({type:e,cb:t})},p.prototype.addBreak=function(){this.pointer++,this.query[this.pointer]=[]},p.prototype.reset=function(){this.query=[],this.pointer=0,this.query[this.pointer]=[]},p.prototype.get=function(){var e,t,n,r,i,s,o,u,a=this.query,f=this.pointer,l=this.operators;if(f===0){e=a[f],t=e.length;if(t===1)return d(e[0]);if(t===2){n=d(e[0]),r=d(e[1]),s=e[1].type;switch(s){case"OR":return function(e){if("undefined"!=typeof n(e))return e;if("undefined"!=typeof r(e))return e};case"AND":return function(e){if("undefined"!=typeof n(e)&&"undefined"!=typeof r(e))return e};case"NOT":return function(e){if("undefined"!=typeof n(e)&&"undefined"==typeof r(e))return e}}}else{if(t!==3)return function(n){var r,i,s,o,u="OR",a=!0;for(r=t-1;r>-1;r--){i=d(e[r]),s=e[r].type,o="undefined"!=typeof i(n);if(s==="OR"){if(o)return n}else if(s==="AND"){if(!o)return;if(u==="OR"&&!a)return}u=s,a=s==="AND"?o:o||a}return n};n=d(e[0]),r=d(e[1]),i=d(e[2]),s=e[1].type,o=e[2].type,s=s+"_"+o;switch(s){case"OR_OR":return function(e){if("undefined"!=typeof n(e))return e;if("undefined"!=typeof r(e))return e;if("undefined"!=typeof i(e))return e};case"OR_AND":return function(e){if("undefined"==typeof i(e))return;if("undefined"!=typeof r(e))return e;if("undefined"!=typeof n(e))return e};case"AND_OR":return function(e){if("undefined"!=typeof i(e))return e;if("undefined"==typeof r(e))return;if("undefined"!=typeof n(e))return e};case"AND_AND":return function(e){if("undefined"==typeof i(e))return;if("undefined"==typeof r(e))return;if("undefined"!=typeof n(e))return e}}}}},v.prototype._add=function(e,t){this.resolve[e]=t},v.prototype._remove=function(e){delete this.resolve[e]},v.prototype.size=function(){return t.size(this.resolve)},v.prototype.get=function(e){return"undefined"==typeof this.resolve[e]?!1:this.nddb.db[this.resolve[e]]},v.prototype.remove=function(e){var t,n;n=this.resolve[e];if("undefined"==typeof n)return!1;t=this.nddb.db[n];if("undefined"==typeof t)return;return this.nddb.db.splice(n,1),delete this.resolve[e],this.nddb.emit("remove",t),this.nddb._autoUpdate(),t},v.prototype.pop=v.prototype.remove,v.prototype.update=function(e,n){var r,i;return i=this.resolve[e],"undefined"==typeof i?!1:(r=this.nddb.db[i],t.mixin(r,n),this.nddb.emit("update",r),this.nddb._autoUpdate(),r)},v.prototype.getAllKeys=function(){return t.keys(this.resolve)},v.prototype.getAllKeyElements=function(){var e={},t;for(t in this.resolve)this.resolve.hasOwnProperty(t)&&(e[t]=this.nddb.db[this.resolve[t]]);return e}})("undefined"!=typeof module&&"undefined"!=typeof module.exports?module.exports:window,"undefined"!=typeof JSUS?JSUS:module.parent.exports.JSUS||require("JSUS").JSUS,"object"==typeof module&&"function"==typeof require?module.parent.exports.store||require("shelf.js/build/shelf-fs.js").store:this.store)